3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
12 # But we protect ourselves from such a user mistake nevertheless.
18 git_broken_path_fix
() {
29 case "$SANE_TOOL_PATH:$elem" in
30 (?
*:/bin | ?
*:/usr
/bin
)
31 path
="$path$sep$SANE_TOOL_PATH"
47 die_with_status
1 "$@"
60 if test -z "$GIT_QUIET"
66 if test -n "$OPTIONS_SPEC"; then
73 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
74 parseopt_extra
="--keep-dashdash"
77 echo "$OPTIONS_SPEC" |
78 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
82 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
84 die
"Usage: $dashless $USAGE"
87 if [ -z "$LONG_USAGE" ]
89 LONG_USAGE
="Usage: $dashless $USAGE"
91 LONG_USAGE
="Usage: $dashless $USAGE
103 set_reflog_action
() {
104 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
106 GIT_REFLOG_ACTION
="$*"
107 export GIT_REFLOG_ACTION
112 if test -z "${GIT_EDITOR:+set}"
114 GIT_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
117 eval "$GIT_EDITOR" '"$@"'
123 GIT_PAGER
=$
(git var GIT_PAGER
)
130 eval "$GIT_PAGER" '"$@"'
134 GREP_OPTIONS
= LC_ALL
=C
grep "$@"
138 GREP_OPTIONS
= LC_ALL
=C
egrep "$@"
141 is_bare_repository
() {
142 git rev-parse
--is-bare-repository
146 cdup
=$
(git rev-parse
--show-toplevel) &&
148 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
153 require_work_tree_exists
() {
154 if test "z$(git rev-parse --is-bare-repository)" != zfalse
156 die
"fatal: $0 cannot be used without a working tree."
160 require_work_tree
() {
161 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
162 die
"fatal: $0 cannot be used without a working tree."
165 require_clean_work_tree
() {
166 git rev-parse
--verify HEAD
>/dev
/null ||
exit 1
167 git update-index
-q --ignore-submodules --refresh
170 if ! git diff-files
--quiet --ignore-submodules
172 echo >&2 "Cannot $1: You have unstaged changes."
176 if ! git diff-index
--cached --quiet --ignore-submodules HEAD
--
180 echo >&2 "Cannot $1: Your index contains uncommitted changes."
182 echo >&2 "Additionally, your index contains uncommitted changes."
189 test -n "$2" && echo >&2 "$2"
194 get_author_ident_from_commit
() {
197 s/'\''/'\''\\'\'\''/g
199 s/^author \([^<]*\) <[^>]*> .*$/\1/
200 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
203 s/^author [^<]* <\([^>]*\)> .*$/\1/
204 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
207 s/^author [^<]* <[^>]*> \(.*\)$/@\1/
208 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
213 encoding
=$
(git config i18n.commitencoding ||
echo UTF-8
)
214 git show
-s --pretty=raw
--encoding="$encoding" "$1" -- |
215 LANG
=C LC_ALL
=C
sed -ne "$pick_author_script"
218 # Clear repo-local GIT_* environment variables. Useful when switching to
219 # another repository (e.g. when entering a submodule). See also the env
220 # list in git_connect()
221 clear_local_git_env
() {
222 unset $
(git rev-parse
--local-env-vars)
226 # Platform specific tweaks to work around some commands
229 # Windows has its own (incompatible) sort and find
236 # git sees Windows-style pwd
240 is_absolute_path
() {
249 is_absolute_path
() {
258 # Make sure we are in a valid repository of a vintage we understand,
259 # if we require to be in a git repository.
260 if test -z "$NONGIT_OK"
262 GIT_DIR
=$
(git rev-parse
--git-dir) ||
exit
263 if [ -z "$SUBDIRECTORY_OK" ]
265 test -z "$(git rev-parse --show-cdup)" ||
{
267 echo >&2 "You need to run this command from the toplevel of the working tree."
271 test -n "$GIT_DIR" && GIT_DIR
=$
(cd "$GIT_DIR" && pwd) ||
{
272 echo >&2 "Unable to determine absolute path of git directory"
275 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}